"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactFormsProcessor = require("react-forms-processor");

var _reactFormsProcessorAtlaskit = require("react-forms-processor-atlaskit");

var _renderer = require("./renderer");

var _renderer2 = _interopRequireDefault(_renderer);

var _definitions = require("./definitions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getDefinedFields = function getDefinedFields(parentContext) {
  if (parentContext && parentContext.parentContext && parentContext.parentContext.parentContext && parentContext.parentContext.parentContext.value && parentContext.parentContext.parentContext.value.fields.length) {
    var value = parentContext.parentContext.parentContext.value.fields;
    if (Array.isArray(value)) {
      var fields = [];
      value.forEach(function (field) {
        if (field.field && field.field.id) {
          fields.push({
            value: field.field.id
          });
        }
      });
      return [{
        items: fields
      }];
    }
  }
  return [];
};

var optionsHandler = function optionsHandler(id, fields, parentContext) {
  if (id === "FIELD") {
    var definedFields = getDefinedFields(parentContext);
    return definedFields;
  }
  return null;
};

var FormBuilder = function (_Component) {
  _inherits(FormBuilder, _Component);

  function FormBuilder(props) {
    _classCallCheck(this, FormBuilder);

    var _this = _possibleConstructorReturn(this, (FormBuilder.__proto__ || Object.getPrototypeOf(FormBuilder)).call(this, props));

    _this.state = {
      previewFields: [],
      builderFields: [],
      previewFormValue: {},
      previewFormButtonDisabled: false
    };
    return _this;
  }

  _createClass(FormBuilder, [{
    key: "onBuilderFormChange",
    value: function onBuilderFormChange(value, isValid) {
      var previewFields = value.fields.map(function (value) {
        return value.field;
      });
      this.setState({
        previewFields: previewFields
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var previewFields = this.state.previewFields;

      return _react2.default.createElement(
        "div",
        { className: "App" },
        _react2.default.createElement(
          "section",
          null,
          _react2.default.createElement(_reactFormsProcessor.Form, {
            defaultFields: _definitions.formBuilder,
            renderer: _renderer2.default,
            onChange: function onChange(value, isValid) {
              _this2.onBuilderFormChange(value, isValid);
            },
            optionsHandler: optionsHandler
          })
        ),
        _react2.default.createElement(
          "section",
          null,
          _react2.default.createElement(
            "div",
            null,
            " Preview "
          ),
          _react2.default.createElement(
            _reactFormsProcessor.Form,
            { defaultFields: previewFields.slice(), renderer: _renderer2.default },
            _react2.default.createElement(_reactFormsProcessorAtlaskit.FormButton, {
              label: "Test",
              onClick: function onClick(value) {
                return console.log("Form preview value", value);
              }
            })
          )
        ),
        _react2.default.createElement(
          "section",
          null,
          _react2.default.createElement(
            "pre",
            null,
            JSON.stringify(previewFields.slice(), null, 2)
          )
        )
      );
    }
  }]);

  return FormBuilder;
}(_react.Component);

exports.default = FormBuilder;